// adjam7
// metadata.cpp

#include "metadata.h"

MetaData::MetaData(QDialog *parent) : QWizardPage()
{
	setupUi(this);

	// creationWebsite -- URL completion
	KUrlCompletion *comp = new KUrlCompletion();
 	creationWebsite->setCompletionObject( comp );
	// Connect to the return pressed signal - optional
 	connect(creationWebsite , SIGNAL( returnPressed(const QString&) ) , comp , SLOT( addItem(const QString&) ) );
	
	registerField("creationName*",creationName);
	registerField("creationAuthor*",creationAuthor);
	registerField("creationVersion*",creationVersion);
	registerField("creationLicense*",creationLicense);
	registerField("creationRequiredVersion",creationRequiredVersion);

	registerField("creationWebsite",creationWebsite);
	registerField("creationEmail",creationEmail);

// set Licenses
	licenses << "" 
		 << "GPL"
		 << "LGPL"
		 << "BSD"
		 << "MPL"
		 << "Creative Commons"
		 <<  "Custom License.."
		;

// set Versions
	versions << ""
		 << "4.0"
		 << "4.1"
		 << "4.2"
		;

// creationLicense addItem
	for (int i = 0; i < licenses.size(); ++i)
		creationLicense->addItem( licenses.at(i) );

// creationRequiredVersion addItem
	for (int i = 0; i < versions.size(); ++i)
		creationRequiredVersion->addItem( versions.at(i) );	
};

QString MetaData::getLicense(int i)
{
	return licenses.at(i);
};

QString MetaData::getRequiredVersion(int i)
{
	return versions.at(i);
};
