// adjam7
// classwizard.cpp

#include "wizmagik.h"

WizMagik::WizMagik(QWidget *parent) : QWizard()
{
	ptCreatePack = new CreatePackage;
	ptMeta = new MetaData;

	addPage(new WelcomePage);
	addPage(new Description);
	addPage(ptMeta);
	addPage(ptCreatePack);

	setWindowTitle("Plasmagik");
};

void WizMagik::accept()
{
// from Description Dialog
	m_strDescription = field("creationDescription").toString();
	m_strReleasesNotes = field("creationNotes").toString();

// from MetaData dialog
	m_strName = field("creationName").toString();
	m_strAuthor = field("creationAuthor").toString();
	m_strVersion = field("creationVersion").toString();

// --- occhio eh..
	m_strLicense = ptMeta->getLicense( field("creationLicense").toInt() ) ;
	m_strRequiredVersion = ptMeta->getRequiredVersion( field("creationRequiredVersion").toInt() );
// ---
	m_strHomePage = field("creationWebsite").toString();
	m_strEmail = field("creationEmail").toString();

// from CreatePackage dialog
	m_strDestinationPath = field("lnLocationPath").toString();
	m_blUpload = field("ckUpload").toBool();

	m_stlFiles = ptCreatePack->getListaFiles();

// -----------------------------------------------
	createPackage();
	
	if( m_blUpload )
		uploadPackage();

	close();
};


// ----------------------------------------------------------------------------

bool WizMagik::createPackage()
{

	Plasma::PackageMetadata metadata;

	metadata.setDescription(m_strDescription);
	metadata.setReleaseNotes(m_strReleasesNotes);
	
	metadata.setName(m_strName);
	metadata.setAuthor(m_strAuthor);
	metadata.setVersion(m_strVersion);
	metadata.setLicense(m_strLicense);
	metadata.setRequiredVersion(m_strRequiredVersion);

	metadata.setWebsite(m_strHomePage);
	metadata.setEmail(m_strEmail);

// --- begin (questi servono per far funzionare il tutto...)
// TODO: sistemare questi..
	metadata.setApplication("tuaSorella");
	metadata.setType("miaSorella");
// --- end
	
	QDir tmpDir;
	tmpDir.mkdir(TMPDIR);

	for(int i = 0; i < m_stlFiles.size(); ++i)
	{
		QString file1path = m_stlFiles.at(i).toLocal8Bit().constData();
		QFile app ( file1path );
		QStringList q =	file1path.split("/");
		QString	file2path = TMPDIR ;
		file2path.append("/");
		file2path.append( q.at( q.size() - 1 ).toLocal8Bit().constData() );
		app.copy( file2path );
	}

	QString destination = m_strDestinationPath;
	destination.append("/");
	destination.append("filename.ext");
	if (!Plasma::Package::createPackage(metadata , TMPDIR , m_strDestinationPath)) 
	{
		KMessageBox::error(this, tr("Some problem occoured during the ""packaging operation.") );
		return false;
	};

	KMessageBox::information( this , tr("Your creation has been successfully packaged!") ,i18n("Plasmoid Packaged!") );

// TODO: removing files and dir from TMPDIR
//	tmpDir.rmdir(TMPDIR);
	return true;
}

// ---------------------------------------------------------------------------

void WizMagik::uploadPackage()
{

};
