// adjam7
// classwizard.h

#include <QWizard>
#include <QString>
#include <QStringList>
#include <QList>
#include <QFile>

#include <KMessageBox>

#include "plasma/package.h"
#include "plasma/packagemetadata.h"

#define	TMPDIR	"/tmp/plasmagik"

#include "welcomepage.h"
#include "description.h"
#include "metadata.h"
#include "createpackage.h"

/** 
* this class implement the wizard pages
* to use to get information about package
*/
class WizMagik : public QWizard
{

public:
/** Constructor. Use to setupUi the widget */
    WizMagik(QWidget *parent = 0);

/** 
* Function. Used to execute all jobs with the 
* files to be packaged 
*/
    void accept();

private:

/** plasmoid description */
	QString m_strDescription;
/** plasmoid releases notes */
	QString m_strReleasesNotes;

/** plasmoid name */
	QString m_strName;
/** plasmoid author*/	
	QString m_strAuthor;
/** plasmoid version */
	QString m_strVersion;
/** plasmoid release license */
	QString m_strLicense;
/** required KDE version for the plasmoid */
	QString m_strRequiredVersion;
/** author home page (optional) */
	QString m_strHomePage;
/** author email (optional) */
	QString m_strEmail;

/** Destination Path. Where the plasmoid would be created. */
	QString m_strDestinationPath;
/** Upload package? (or not??) */
	bool m_blUpload;
/** List of the files to be packaged */
	QStringList m_stlFiles;

/** pointer to CreatePackage. Useful to retrieve information about files. */
	CreatePackage *ptCreatePack;

/** pointer to CreatePackage. Useful to retrieve information about files. */
	MetaData *ptMeta;	
/** Function. Brings metadata and files to create the package. */
	bool createPackage();

/** Function. Upload package. */
	void uploadPackage();
};
